## kdbg-3.0.1-1.src.tar.gz

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.3)
set(QT_MIN_VERSION "5.4.0")
set(KF5_MIN_VERSION "5.2.0")

set(KDBG_VERSION 3.0.1)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/kdbg/version.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/kdbg/version.h)

find_package(ECM REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH} ${ECM_KDE_MODULE_DIR})

find_package(Qt5 ${QT_MIN_VERSION} CONFIG REQUIRED COMPONENTS
    Core Widgets
)

find_package(KF5 ${KF5_MIN_VERSION} REQUIRED COMPONENTS
    I18n
    Config
    IconThemes
    XmlGui
    WindowSystem
)

include(KDEInstallDirs)
include(KDECompilerSettings)
include(KDECMakeSettings)
include(FeatureSummary)

add_subdirectory(kdbg)
add_subdirectory(po)

feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== kdbg/CMakeLists.txt ===
add_subdirectory(doc)
add_subdirectory(pics)
add_subdirectory(typetables)

include(CheckFunctionExists)
include(CheckIncludeFiles)
include(CheckLibraryExists)
include(ECMAddAppIcon)

CHECK_INCLUDE_FILES(pty.h HAVE_PTY_H)
CHECK_INCLUDE_FILES(libutil.h HAVE_LIBUTIL_H)
CHECK_INCLUDE_FILES(util.h HAVE_UTIL_H)
CHECK_LIBRARY_EXISTS(util openpty "" HAVE_LIB_UTIL)
if (HAVE_LIB_UTIL)
    set(CMAKE_REQUIRED_LIBRARIES util)
endif (HAVE_LIB_UTIL)
CHECK_FUNCTION_EXISTS(openpty HAVE_FUNC_OPENPTY)

message("-- Looking for a suitable 'ps' invocation")
FIND_PROGRAM(PROG_PS ps)
IF (PROG_PS)
    set(PS_ARGS -eo pid,ppid,uid,vsz,etime,time,args)
    execute_process(COMMAND ${PROG_PS} ${PS_ARGS}
		RESULT_VARIABLE PS_FAILED
		OUTPUT_QUIET ERROR_QUIET)
    IF (NOT PS_FAILED)
	execute_process(
		COMMAND ${PROG_PS} ${PS_ARGS}
		COMMAND sed -e "s/  */ /g" -e 1q
		OUTPUT_VARIABLE PS_HEADER)
	string(STRIP "${PS_HEADER}" PS_HEADER)
	IF (PS_HEADER STREQUAL "PID PPID UID VSZ ELAPSED TIME COMMAND")
	    # enclose arguments in double-quotes
	    set(PS_COMMAND \"${PROG_PS}\")
	    set(PS_MSG ${PROG_PS})
	    foreach (I ${PS_ARGS})
		set(PS_COMMAND ${PS_COMMAND},\"${I}\")
		set(PS_MSG "${PS_MSG} ${I}")
	    endforeach (I)
	    message("-- Found 'ps' command: ${PS_MSG}")
	ENDIF (PS_HEADER STREQUAL "PID PPID UID VSZ ELAPSED TIME COMMAND")
    ENDIF (NOT PS_FAILED)
ENDIF (PROG_PS)
IF (NOT PS_COMMAND)
    message("-- Looking for a suitable 'ps' invocation - not found")
ENDIF (NOT PS_COMMAND)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h)

set(kdbg_SRCS
    pgmargs.cpp
    procattach.cpp
    debugger.cpp
    dbgdriver.cpp
    gdbdriver.cpp
    xsldbgdriver.cpp
    brkpt.cpp
    exprwnd.cpp
    regwnd.cpp
    memwindow.cpp
    threadlist.cpp
    sourcewnd.cpp
    winstack.cpp
    ttywnd.cpp
    typetable.cpp
    prefdebugger.cpp
    prefmisc.cpp
    pgmsettings.cpp
    watchwindow.cpp
    dbgmainwnd.cpp
    main.cpp
)

set(kdbg_UI
    brkptbase.ui
    brkptcondition.ui
    pgmargsbase.ui
    procattachbase.ui
)

ki18n_wrap_ui(kdbg_SRCS ${kdbg_UI})

file(GLOB ICONS_SRCS "${CMAKE_CURRENT_SOURCE_DIR}/pics/*-apps-kdbg.png")
ecm_add_app_icon(kdbg_SRCS ICONS ${ICONS_SRCS})
add_executable(kdbg ${kdbg_SRCS})

IF (HAVE_LIB_UTIL)
    set(LIB_UTIL util)
ENDIF (HAVE_LIB_UTIL)

target_link_libraries(kdbg
    KF5::I18n
    KF5::ConfigCore
    KF5::IconThemes
    KF5::XmlGui
    KF5::WindowSystem
    ${LIB_UTIL}
)

install(TARGETS kdbg ${INSTALL_TARGETS_DEFAULT_ARGS})
install(FILES kdbg.desktop DESTINATION ${XDG_APPS_INSTALL_DIR})
install(FILES kdbgrc DESTINATION ${CONFIG_INSTALL_DIR})
install(FILES kdbgui.rc DESTINATION ${KXMLGUI_INSTALL_DIR}/kdbg)

=== kdbg/pics/CMakeLists.txt ===
include(ECMInstallIcons)

# compress SVG files
file(GLOB svgs RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}"
	"${CMAKE_CURRENT_SOURCE_DIR}/sc-*.svg")
set(svgzs)
foreach(svg ${svgs})
	set(svgz "${CMAKE_CURRENT_BINARY_DIR}/${svg}z")
	add_custom_command(
		OUTPUT "${svgz}"
		COMMAND gzip < "${CMAKE_CURRENT_SOURCE_DIR}/${svg}" > "${svgz}"
		DEPENDS "${svg}"
	)
	set(svgzs ${svgzs} "${svgz}")
endforeach(svg)
add_custom_target(generatesvgz ALL DEPENDS ${svgzs})

# line items and other pictograms
set(PICTOGRAMS
	brkena.png
	brkdis.png
	brktmp.png
	brkcond.png
	brkorph.png
	pcinner.png
	pcup.png
	watchena.png
	watchdis.png
	pointer.xpm)

install(FILES ${PICTOGRAMS} DESTINATION "${DATA_INSTALL_DIR}/kdbg/pics")

ecm_install_icons(ICONS
    22-actions-pulse.mng
    DESTINATION "${DATA_INSTALL_DIR}/kdbg/icons"
    THEME hicolor
)
ecm_install_icons(ICONS
    16-apps-kdbg.png
    32-apps-kdbg.png
    48-apps-kdbg.png
    64-apps-kdbg.png
    128-apps-kdbg.png
    ${CMAKE_CURRENT_BINARY_DIR}/sc-apps-kdbg.svgz
    DESTINATION "${DATA_INSTALL_DIR}/icons"
    THEME hicolor
)
ecm_install_icons(ICONS
    16-actions-brkpt.png
    16-actions-debug-run.png
    16-actions-document-open-executable.png
    22-actions-brkpt.png
    22-actions-debug-run.png
    22-actions-document-open-executable.png
    32-actions-brkpt.png
    32-actions-debug-run.png
    32-actions-document-open-executable.png
    48-actions-brkpt.png
    48-actions-debug-run.png
    48-actions-document-open-executable.png
    ${CMAKE_CURRENT_BINARY_DIR}/sc-actions-brkpt.svgz
    ${CMAKE_CURRENT_BINARY_DIR}/sc-actions-debug-run.svgz
    ${CMAKE_CURRENT_BINARY_DIR}/sc-actions-document-open-executable.svgz
    DESTINATION "${DATA_INSTALL_DIR}/kdbg/icons"
    THEME oxygen
)

=== kdbg/testprogs/Makefile ===
CXXFLAGS=-O0 -g

QT5INC = -I/usr/include/qt5 -fPIC
QT5LIB = /usr/lib64/libQt5Core.so

PROGS = \
	anonstruct \
	funcnames \
	helloworld \
	locals \
	longdouble \
	maths \
	multibrkpt \
	nestedclass \
	qt \
	repeats \
	std \
	templates \
	testfile \
	tooltips \
	widechar

all: $(PROGS)

anonstruct: anonstruct.cpp
	g++ -o $@ $(CXXFLAGS) $^

funcnames: funcnames.cpp
	g++ --std=c++11 -o $@ $(CXXFLAGS) $^

helloworld: helloworld.asm
	nasm -f elf64 -F dwarf -g $^ -o $(^:.asm=.o)
	ld -g -o $@ $(^:.asm=.o)

locals: locals.cpp
	g++ -o $@ $(CXXFLAGS) $^

longdouble: longdouble.c
	gcc -o $@ $(CXXFLAGS) $^

maths: maths.cpp
	g++ -o $@ $(CXXFLAGS) $^

multibrkpt: multibrkpt.cpp
	g++ -o $@ $(CXXFLAGS) $^

nestedclass: nestedclass.cpp
	g++ -o $@ $(CXXFLAGS) $^

qt: qt.cpp
	g++ -o $@ $(CXXFLAGS) $^ $(QT5INC) $(QT5LIB)

repeats: repeats.cpp
	g++ -o $@ $(CXXFLAGS) $^ $(QT5INC) $(QT5LIB)

std: std.cpp
	g++ -o $@ $(CXXFLAGS) $^

templates: templates.cpp
	g++ -std=c++0x -o $@ $(CXXFLAGS) $^

testfile: testfile.cpp
	g++ -o $@ $(CXXFLAGS) $^ $(QT5INC) $(QT5LIB)

tooltips: tooltips.cpp
	g++ -o $@ $(CXXFLAGS) $^

widechar: widechar.cpp
	g++ -o $@ $(CXXFLAGS) $^


clean:
	$(RM) $(PROGS)

=== kdbg/typetables/CMakeLists.txt ===
install(FILES
	qt.kdbgtt
	qt2.kdbgtt
	qt3.kdbgtt
	qt4core.kdbgtt
	qt5core.kdbgtt
	kdecore.kdbgtt
	kdecore3.kdbgtt
	glib.kdbgtt
	gtk+.kdbgtt
	stdc++.kdbgtt
	stdc++6.kdbgtt
	X11.kdbgtt
	DESTINATION ${DATA_INSTALL_DIR}/kdbg/types)

=== PKGBUILD ===
# Maintainer: Antonio Rojas <arojas@archlinux.org>
# Contributor: Sergej Pupykin <pupykin.s+arch@gmail.com>
# Contributor: Eric Belanger <belanger@astro.umontreal.ca>
# Contributor: Jason Taylor <jftaylor21@gmail.com>
# Contributor: Georg Grabler <ggrabler@chello.at>

pkgname=kdbg
pkgver=3.0.1
pkgrel=1
pkgdesc="A graphical debugger interface"
arch=(x86_64)
url="http://www.kdbg.org"
license=(GPL)
depends=(gdb kxmlgui hicolor-icon-theme)
makedepends=(extra-cmake-modules)
source=("https://downloads.sourceforge.net/project/kdbg/Source%20Code/$pkgver/kdbg-$pkgver.tar.gz")
sha256sums=('449df80e7c1de05b2ce9c844707f005bfb7e4e833f870ff8b3756b4469375dbd')

prepare() {
  mkdir -p build
}

build() {
  cd build
  cmake ../$pkgname-$pkgver
  make
}

package() {
  cd build
  make DESTDIR="$pkgdir" install
}
